''' <summary>
''' Diese Klasse liefert fr zwei Arrays mit je 20 Farben (als Gradient) 
''' in festgelegten Timer-Intervallen eine aktuelle Farb-Kombination  
''' </summary>

Public Class BiColorTimer

    ''' <summary>
    ''' Event bei nderung der Farben
    ''' </summary>
    Public Event Colors_Changed()

#Region " Konstruktoren "
    Public Sub New()
        m_Timer = New Timer
    End Sub
    ''' <summary>
    ''' </summary>
    ''' <param name="GradientColors1">Basisfarben1 fr den Farbverlauf</param>
    ''' <param name="GradientColors2">Basisfarben2 fr den Farbverlauf</param>
    ''' <param name="Milliseconds">Dauer in Millisekunden fr den gesamten Farbwechsel</param>
    Public Sub New(ByVal GradientColors1 As GradientCollection, ByVal GradientColors2 As GradientCollection, ByVal Milliseconds As Integer)
        m_GradientColors1 = GradientColors1
        m_GradientColors2 = GradientColors2
        m_Timer = New Timer
        Dim ms As Single = Math.Max(0.0F, Math.Min(Milliseconds, 2000.0F))
        m_Timer.Interval = Math.Max(1, Math.Round(ms / 20.0F))
    End Sub
#End Region

#Region " Private Felder "

    ' Array Nummer 1 mit Basis-Farben, die angezeigt werden knnen
    Private m_GradientColors1 As GradientCollection

    ' Array Nummer 2 mit Basis-Farben, die angezeigt werden knnen
    Private m_GradientColors2 As GradientCollection

    ' aktueller Farb-Index
    Private m_ColorIndex As Integer = 0

    'Timer zur Steuerung des Farbwechsels
    Private WithEvents m_Timer As Timer

#End Region

#Region " Properties "
    ''' <summary>
    ''' Aktive Farbe
    ''' </summary>
    ReadOnly Property ActiveColors() As BiColor
        Get
            Return New BiColor(m_GradientColors1.Colors(m_ColorIndex), m_GradientColors2.Colors(m_ColorIndex))
        End Get
    End Property
#End Region

#Region " Methoden "
    ''' <summary>
    ''' fhrt zum ndern des aktuellen Farbindex und zum Auslsen des nderungs-Events
    ''' </summary>
    Private Sub m_Timer_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles m_Timer.Tick
        If m_ColorIndex < 19 Then
            m_ColorIndex += 1
            RaiseEvent Colors_Changed()
        Else
            m_Timer.Stop()
        End If
    End Sub
    Public Sub StartTimer()
        m_Timer.Start()
    End Sub
    Public Sub StopTimer()
        m_Timer.Stop()
    End Sub
#End Region

End Class


