Public Class Form1

#Region " Private Felder "

    ' Renderer zum Zeichnen von ToolStrips und selbst gezeichneten Controls
    Private m_Renderer As ColorWheelToolStripRenderer
    ' Liste mit anzuzeigenden Bild-Text-Elementen
    Private WithEvents myItems As New ListItemListe
    ' aktuell selektiertes Bild-Text-Element
    Private m_SelectedItem As ListItem = Nothing
    ' Flag, whrend der Initialisierung True
    Private m_Init As Boolean = True

    ' rahmenlose Windows Form zum Anzeigen der Farbauswahl
    Private WithEvents m_frm_Colors As frm_Colors

#End Region

#Region " Konstruktoren "

    Public Sub New()

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fgen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.
        Me.ListPainter1.Font = New System.Drawing.Font("Segoe UI", 8.25F)

        ' Renderer neu erstellen
        m_Renderer = New ColorWheelToolStripRenderer(New ColorWheelProfessionalTable)
        m_Renderer.ControlHue = 0.6R

        ' alle beteilgten Controls erhalten eine Referenz auf den gleichen Renderer
        Me.ToolStrip1.Renderer = m_Renderer
        Me.StatusStrip1.Renderer = m_Renderer
        Me.BitmapPainter1.Renderer = m_Renderer
        Me.ListPainter1.Renderer = m_Renderer

        ' neue Items zur Liste hinzufgen
        myItems.Add(New ImageTextItem(My.Resources.Kiwi, "Kiwi" & vbCrLf & "30,3KB"))
        myItems.Add(New ImageTextItem(My.Resources.Dahlie1, "Dahlie1" & vbCrLf & "54,3KB"))
        myItems.Add(New ImageTextItem(My.Resources.Dahlie2, "Dahlie2" & vbCrLf & "40,5KB"))
        myItems.Add(New ImageTextItem(My.Resources.Dahlie3, "Dahlie3" & vbCrLf & "39,9KB"))
        myItems.Add(New ImageTextItem(My.Resources.Dahlie4, "Dahlie4" & vbCrLf & "51,3KB"))
        myItems.Add(New ImageTextItem(My.Resources.Dahlie5, "Dahlie5" & vbCrLf & "67,0KB"))
        myItems.Add(New ImageTextItem(My.Resources.Rose, "Rose" & vbCrLf & "39,1KB"))

        ' Initialisierungs-Flag auf False setzen
        m_Init = False
        ' selektierten Index in der Item-Liste neu festlegen
        myItems.SelectedIndex = 0

        ' der ListPainter erhlt die Item-Liste als Referenz 
        Me.ListPainter1.Items = myItems
    End Sub

#End Region

#Region " Methoden "

    ''' <summary>
    ''' Eventhandler fr die Changed-Events der Item-Liste
    ''' </summary>
    Private Sub myItems_SelectedItemChanged() Handles myItems.SelectedItemChanged, myItems.Changed
        If m_Init Then Exit Sub
        ' nur wenn sich SelectedItem wirklich gendert hat
        If m_SelectedItem IsNot myItems.SelectedItem Then
            ' SelectedItem mit eigener Referenz merken
            m_SelectedItem = myItems.SelectedItem

            ' Bild- und Textanzeige aktualisieren
            If m_SelectedItem Is Nothing Then
                Me.BitmapPainter1.Bitmap = Nothing
                Me.ToolStripStatusLabel1.Text = ""
            Else
                Dim Item As ImageTextItem = myItems.SelectedItem
                Me.BitmapPainter1.Bitmap = Item.Image
                Dim Text As String = Item.Text.Replace(vbCrLf, " ")
                Me.ToolStripStatusLabel1.Text = Text
            End If
        End If
    End Sub


    ''' <summary>
    ''' zeigt eine rahmenlose Windows Form zur Farbauswahl an
    ''' </summary>
    Private Sub HintergrundfarbeToolStripButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles HintergrundfarbeToolStripButton.Click

        ' wenn bereits eine Instanz der Form angezeigt wird, ist nichts zu tun
        If m_frm_Colors IsNot Nothing Then Exit Sub

        ' neue Windows Form zur Farbauswahl mit aktuellem Renderer instanziieren
        m_frm_Colors = New frm_Colors(m_Renderer)
        ' Startposition der Windows Form am Platz des ToolStripButtons festlegen
        m_frm_Colors.StartPosition = FormStartPosition.Manual
        m_frm_Colors.Location = Me.PointToScreen(New Point(Me.HintergrundfarbeToolStripButton.Bounds.X, Me.HintergrundfarbeToolStripButton.Bounds.Bottom))
        ' Farbauswahl-Form anzeigen
        m_frm_Colors.Show()
        m_frm_Colors.Focus()
    End Sub


    ''' <summary>
    ''' wenn die Farbauswahl-Form den Focus verliert, wird diese geschlossen
    ''' </summary>
    Private Sub m_frm_Colors_Deactivate(ByVal sender As Object, ByVal e As System.EventArgs) Handles m_frm_Colors.Deactivate
        m_frm_Colors.Close()
    End Sub

    ''' <summary>
    ''' wenn die Farbauswahl-Form geschlossen wird, Referenz auf Nothing setzen
    ''' </summary>
    Private Sub m_frm_Colors_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles m_frm_Colors.FormClosing
        m_frm_Colors = Nothing
    End Sub

#End Region

End Class
