Imports System.Drawing.Drawing2D
''' <summary>
''' Klasse zum Zeichnen eines ImageTextItems
''' </summary>
Public Class ImageTextPaintItem
    Inherits ListPaintItem

#Region " Private Felder "

    ' Image-Objekt mit 48 Pixel Kantenlnge
    Private m_Image As Image
    ' Text
    Private m_Text As String

#End Region

#Region " Konstruktoren "

    ''' <summary>
    ''' Konstruktor fr ein ImageTextPaintItem
    ''' </summary>
    ''' <param name="Image">Image-Objekt mit 48 Pixel Kantenlnge</param>
    ''' <param name="Text">Text</param>
    ''' <param name="Selected">True, wenn das ListItem selektiert ist</param>
    Public Sub New(ByVal Image As Image, ByVal Text As String, ByVal Selected As Boolean)
        MyBase.New(Selected)
        m_Image = Image
        m_Text = Text
    End Sub

#End Region

#Region " Methoden "

    ''' <summary>
    ''' zeichnet das ImageTextPaintItem auf einem Graphics-Objekt
    ''' </summary>
    ''' <param name="e">PaintEventArgs</param>
    Public Overrides Sub OnPaint(ByVal e As System.Windows.Forms.PaintEventArgs)
        ' OnPaint in der Basisklasse aufrufen, dort wird der Hintergrund gezeichnet
        MyBase.OnPaint(e)

        If e.ClipRectangle.IntersectsWith(Me.Rectangle) Then
            Dim g As Graphics = e.Graphics
            ' Bildchen mit 48 Pixel Kantenlnge zeichnen
            g.DrawImage(m_Image, New Point(Me.Rectangle.X + 4, Me.Rectangle.Y + 4))
            ' um dieses Bild einen Rahmen mit 50 Pixel Kantenlnge zeichnen
            g.DrawRectangle(Me.Control.Renderer.MenuItemBorderPen, New Rectangle(Me.Rectangle.X + 2, Me.Rectangle.Y + 2, 51, 51))
            Dim Width As Integer = Me.Rectangle.Width - 64
            If Width > 0 Then
                ' Wenn genug Platz fr den Text ist, den Text zeichnen
                Dim flags As TextFormatFlags = TextFormatFlags.WordEllipsis Or TextFormatFlags.VerticalCenter
                TextRenderer.DrawText(e.Graphics, m_Text, Me.Control.Font, _
                New Rectangle(60, Me.Rectangle.Top + 2, Width, Me.Rectangle.Height - 4), _
                SystemColors.ControlText, flags)
            End If
        End If
    End Sub

    ''' <summary>
    ''' gibt Ressourcen frei
    ''' </summary>
    Public Overrides Sub DisposeBitmap()
        m_Image.Dispose()
    End Sub

#End Region

End Class
