Public Class GlassScrollBar
    Inherits CustomScrollBarBase
    Public Sub New()
        MyBase.New(New GlassScrollBarPainter)
        m_Renderer = New ColorWheelToolStripRenderer(New ColorWheelProfessionalTable)
        GetRendererColors()
    End Sub

    Private WithEvents m_Renderer As ColorWheelToolStripRenderer
    Shadows Property Renderer() As ColorWheelToolStripRenderer
        Get
            Return m_Renderer
        End Get
        Set(ByVal value As ColorWheelToolStripRenderer)
            If value IsNot Nothing Then
                m_Renderer = value
                GetRendererColors()
                Invalidate()
            End If
        End Set
    End Property
    Private Sub m_Renderer_Changed() Handles m_Renderer.Changed
        GetRendererColors()
        Invalidate()
    End Sub
    Private Sub GetRendererColors()
        Me.BackColor = m_Renderer.ControlBackColor
        Me.ForeColor = m_Renderer.ColorTable.ToolStripGradientMiddle
        Me.HooverColor = m_Renderer.ColorTable.MenuItemPressedGradientBegin
        Me.SelectionColor = m_Renderer.ColorTable.MenuItemPressedGradientEnd
    End Sub
End Class
