Public Class frm_Colors

#Region " Private Felder "

    ' Flag, whrend der Initialisierung True
    Private m_Init As Boolean = True

    ' verwendeter Renderer 
    Private WithEvents m_Renderer As ColorWheelToolStripRenderer

#End Region

#Region " Konstruktoren "

    ''' <summary>
    ''' Konstruktor fr eine Instanz der Windows Form mit fest stehendem Renderer
    ''' </summary>
    Public Sub New(ByVal Renderer As ColorWheelToolStripRenderer)

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fgen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.

        ' Referenz zur bergebenen Renderer-Instanz
        m_Renderer = Renderer

        ' Referenz zur Farbtabelle, aktuellen Hue-Wert und Dehnungsfaktor an das 
        ' Control zur Farbauswahl bergeben
        Me.ColorWheelProfessionalTableControl1.Table = m_Renderer.BaseTable
        Me.ColorWheelProfessionalTableControl1.StretchFactor = m_Renderer.StretchFactor
        Me.ColorWheelProfessionalTableControl1.Hue = m_Renderer.ControlHue
        m_Init = False

        ' eigene Hintergrundfarbe festlegen
        Me.BackColor = m_Renderer.ControlBackColor

        ' DoubleBuffering aktivieren
        Me.SetStyle(ControlStyles.DoubleBuffer Or ControlStyles.UserPaint _
         Or ControlStyles.AllPaintingInWmPaint, True)
    End Sub

#End Region

#Region " Methoden "

    ' Handler fr das Changed-Event des Renderers
    Private Sub m_Renderer_Changed() Handles m_Renderer.Changed
        Me.BackColor = m_Renderer.ControlBackColor
    End Sub

    ''' <summary>
    ''' berschreiben der OnPaintBackground-Methode der Windows Form
    ''' </summary>
    Protected Overrides Sub OnPaintBackground(ByVal e As System.Windows.Forms.PaintEventArgs)
        MyBase.OnPaintBackground(e)
        Dim g As Graphics = e.Graphics
        ' Rahmen zeichnen
        g.DrawLine(m_Renderer.SeparatorLightPen, 0, 0, Me.Width - 1, 0)
        g.DrawLine(m_Renderer.SeparatorDarkPen, 0, Me.Height - 1, Me.Width - 1, Me.Height - 1)
        g.DrawLine(m_Renderer.SeparatorLightPen, 0, 0, 0, Me.Height - 1)
        g.DrawLine(m_Renderer.SeparatorDarkPen, Me.Width - 1, 0, Me.Width - 1, Me.Height - 1)
    End Sub

    ''' <summary>
    ''' Handler fr das Changed-Event des Farbauswahl-Controls
    ''' </summary>
    Private Sub ColorWheelProfessionalTableControl1_Changed() Handles ColorWheelProfessionalTableControl1.Changed
        ' nach nderung der Farbauswahl Werte fr Hue und Dehnungsfaktor im eigenen Renderer bernehmen
        m_Renderer.SetHueAndStretchFactor(ColorWheelProfessionalTableControl1.Hue, ColorWheelProfessionalTableControl1.StretchFactor)
    End Sub

#End Region

End Class